<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - File Level</TITLE>
<link href="suif1_3.html" rel=Next>
<link href="suif1_1.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_1.html">previous</A>, <A HREF="suif1_3.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC2" HREF="suif1_toc.html#TOC2">The File Level</A></H2>

<P>
SUIF is designed to support interprocedural analysis and optimization
with separate compilation.  At the root of the hierarchy for a SUIF
program is a <STRONG>file set</STRONG> containing a list of the files being
compiled.  See section <A HREF="suif1_8.html#SEC8">The File Set</A>.  Each entry within the file set is a
<STRONG>file set entry</STRONG> that contains the input and output streams for a
particular file.  See section <A HREF="suif1_9.html#SEC9">File Set Entries</A>.

</P>
<P>
The file level of the SUIF hierarchy also contains the global symbol
tables.  The file set contains the global symbol table that is shared
across all of the files.  This shared symbol table is the key to
supporting interprocedural analysis.  References to a global symbol or
type from different files can point to the same entry in the shared
global symbol table, making it easy to determine that they refer to the
same entity.  Each file set entry also contains its own symbol table for
things declared privately within that file.

</P>
<P>
Lower levels of the SUIF hierarchy can be reached through the global
symbol tables.  Besides the types and variables, the global symbol
tables contain symbols for the procedures.  The procedure bodies can be
accessed through these procedure symbols.  If the body of a procedure is
contained in one of the input files, the corresponding procedure symbol
automatically records a pointer to the input file and provides a method
to read the body into memory.  The procedure symbol also has other
methods to write the body to an output file and to flush the body from
memory.  Many SUIF programs need to process all the procedures.  This
can be done by searching through the global symbol tables for the
procedure symbols.  However since this is such a common task, the file
set entries include procedure iterators to step through all the
procedures.

</P>
<P>
For passes that work on one file at a time, the file set is not worth
much, but it is very helpful for interprocedural passes.  Without it,
they would have to combine all the code into one big file.  While
that may not be an unreasonable solution, SUIF file sets provide the
benefits of separate compilation with only a moderate increase in
complexity.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_1.html">previous</A>, <A HREF="suif1_3.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
